function KwaxTTS() {
  //
}

KwaxTTS.prototype = {
  isAvailable: function () {
    return new Promise(function (resolve, reject) {

      if (chrome.runtime.lastError) {
        console.error(chrome.runtime.lastError);
        reject(chrome.runtime.lastError);
        return;
      }
      if (document.querySelector('#speakBtn') === null) {
        resolve('')
      } else if (document.querySelector('#speakBtn').getAttribute('tts-onoff') === null) {
        resolve('')
      } else {
        resolve(document.querySelector('#speakBtn').getAttribute('tts-onoff'));
      }
    });
  },

  isSpeak: function () {
    return new Promise(function (resolve, reject) {
      chrome.runtime.sendMessage({
        payload: "isactive"
      }, function (response) {
        if (chrome.runtime.lastError) {
          console.error(chrome.runtime.lastError);
          reject(chrome.runtime.lastError);
          return;
        }
        resolve(response.active);
      });
    });
  },

  _onDisabledDetected: function () {
    var remove = [].slice.call(document.querySelectorAll('screenreader-highlight'));
    remove.forEach(function (node) {
      node.classList.remove('screenreader-highlight');
    });
  },

  observe: function () {
    //    document.body.addEventListener('mouseover', this.overAction.bind(this));
    //  document.body.addEventListener('mouseout', this.outAction.bind(this));
    //document.body.addEventListener('click', this.clickAction.bind(this));
      document.body.addEventListener('click', this.mouseUpAction.bind(this), true);

    document.body.addEventListener('focus', this.focusAction.bind(this), true);
  },

  overAction: function (e) {
    console.log('overAction in !')
 
  },

  outAction: function (e) {
    var node = e.target;
    if (node.classList.contains('screenreader-highlight')) {
      node.classList.remove('screenreader-highlight');
    }
  },

mouseUpAction: function (e) {
  var node = e.target;
//  console.log('mouseUpAction in. e.target(node)=' + node);
//  console.log("e.checked=" + e.checked);
},

  focusAction: function (e) {
    var node = e.target; //https://mail.google.com/mail/?tab=wm&ogbl
    //  var node = e.target.nodeName;
    this.isAvailable().then(function (available) {
/*  
      if (!available) {
        return;
      }
*/      
      var clone = e.target.cloneNode(true); // clone === node
      var remove = [].slice.call(clone.querySelectorAll('script,style,object,embed,svg'));
      remove.forEach(function (node) {
        node.parentNode.removeChild(node);
      });

      var txt = "";
if (clone.tabIndex !='-1'  && clone.nodeName!='DIV') {
  var txt = this._getNodeText(clone).trim();
          txt = txt.replace(/[\s]{2,}/gi, ' ').trim();
      }
      if (txt === "") {
        return;
      }
      //this.play(e.target.nodeName + " " + txt);
      // 제일 첫 글자가 제대로 안들리는 문제가 있음
      txt = " " + txt

console.log('txt=' + txt);

//this.play(replaceProductName(txt));
this.play(txt);
      //clone.getAttribute('type') ? console.log("type=" + clone.getAttribute('type')) :  console.log("type=nono");
    }.bind(this));
  },

  /**
   * Get text value for node and sub-nodes.
   */
  _getNodeText: function (element) {

    var result = '';
    var strAttType = '';
    var strAttValue = '';
    var strReadText = '';
//    console.log("Start ===" + element + " ========= , element.childNodes.length=" + element.childNodes.length);
    
      if ((element.childNodes.length > 0) && (element.nodeName!='SELECT')) {      
      for (var i = 0; i < element.childNodes.length; i++) {
       // console.log("childNodes[" + i + "]===" + element.childNodes[i]);
        result += this._getNodeText(element.childNodes[i]) + ' ';
      }
    }
   
   if (element.nodeType === Node.TEXT_NODE) { // ykk 0918 수정
      result += element.parentNode.nodeValue
      result += element.nodeValue.trim();


    }


    if (element.nodeType === Node.ELEMENT_NODE) {  // a, em, span, 
//      console.log("In element.nodeType === Node.ELEMENT_NODE > " + element.nodeName)
      //strAttType = this.eleCodeToName(element.nodeName);
      var eleid = element.getAttribute('id');
  //    console.log("eleid=" + eleid);
      switch (element.nodeName) {
        case 'INPUT':
            switch(element.getAttribute('type')) {
                  case 'text' :
                      //strAttValue =  document.querySelector('[for="' + eleid +'"]').innerText;
                      strAttValue =  document.querySelector('[for="' + eleid +'"]') ? document.querySelector('[for="' + eleid +'"]').innerText : '';
                      strAttValue = strAttValue + (element.getAttribute ? element.getAttribute('title') : '');
                      strAttValue = strAttValue + (element.getAttribute ? element.getAttribute('placeholder') : '');
                      strAttValue = strAttValue + (element.getAttribute ? element.getAttribute('value') : '') ;
                      strAttType = "편집창" ;
                      break;
                   case 'password' :
                     strAttValue =  document.querySelector('[for="' + eleid +'"]') ? document.querySelector('[for="' + eleid +'"]').innerText : '';
                      strAttValue = strAttValue + (element.getAttribute ? element.getAttribute('title') : '');
                      strAttType = "암호편집창" ;
                      break;
                  case 'radio' :  //읽기순서 : 선택상태 - label - value - 라디오버튼
/*                  
                    if (document.getElementById(eleid).checked) {
                      strAttValue = "선택";
                    } else {
                      strAttValue = "해제";
                    }
*/                    
                    strAttValue = "" // 마우스 클릭시 focus 후에 click이 발생하여 선택 / 해제를 정확하게 읽어주지 못하므로 막음

                    strAttValue = strAttValue + (document.querySelector('[for="' + eleid +'"]') ? document.querySelector('[for="' + eleid +'"]').innerText : '');
                    strAttValue = strAttValue + (element.getAttribute ? element.getAttribute('value') : '');
                    strAttType = "라디오버튼" ;
                      break;
                  case 'checkbox':   //읽기순서 : 선택상태 - label - title - 체크상자
                  
                      strAttValue = "" // 마우스 클릭시 focus 후에 click이 발생하여 선택 / 해제를 정확하게 읽어주지 못하므로 막음
                      strAttValue = strAttValue + (document.querySelector('[for="' + eleid +'"]') ? document.querySelector('[for="' + eleid +'"]').innerText : '');
                      strAttValue = strAttValue + (element.getAttribute ? element.getAttribute('title') : '');
                      strAttType = "체크상자" ;
                      break;
                  case 'button' :  //읽기순서 : value - 버튼
                      strAttValue = (element.getAttribute ? element.getAttribute('value') : '') ;
                      strAttType = "버튼" ;
                      break;
                  case 'submit' :  //value - 서브 및 버튼
                      strAttValue = (element.getAttribute ? element.getAttribute('value') : '') ;
                      strAttType = "서브밋버튼" ;
                      break;
                 }
              strReadText = strAttValue  + " " +  strAttType  ;        
          break;
          case 'A':
//            console.log("come in A");
            strAttType =  "링크";
            // strAttValue = element.getAttribute ? element.getAttribute('title')  + '&' +  element.getAttribute('href') + '&' +  element.getAttribute('onclick'): '';   
            strAttValue = element.getAttribute ? element.getAttribute('title') : '';
            strReadText = strAttType + " " + strAttValue
            break;
          case 'BUTTON':
              strAttValue =  (element.getAttribute ? element.getAttribute('value') : '') ;
//              strAttValue = strAttValue + (element.getAttribute ? element.getAttribute('title') : '');  0 으로 읽는 오류
              strAttType =  "버튼";
              strReadText =  strAttType  + " "  + strAttValue ;
              break;
           case 'IMG':
//            strAttType = element.nodeName + " "
            strAttType = "이미지"
              
//              strAttValue = element.getAttribute ? element.getAttribute('alt') : '';
              strAttValue = element.getAttribute('alt') ? element.getAttribute('alt') : '누락된 설명';      
              console.log('img alt 읽기 == ' + strAttValue) ;
              strReadText = strAttValue + strAttType
          break;
        case 'SELECT':
        // read order :  label의innerText - select의 title속성 - 콤보상자 - 첫번째option의 text
            strAttValue = document.querySelector('[for="' + eleid +'"]') ? document.querySelector('[for="' + eleid +'"]').innerText : '';
            strAttValue = strAttValue + ( element.getAttribute ? element.getAttribute('title') : '' );
            strAttValue = strAttValue +  "콤보상자" + " "
            strAttValue = strAttValue + element.options[element.options.selectedIndex].text; 
            //problem  not read element.options[element.options.selectedIndex].text  only read first option (element.options[0].text)

            strReadText = strAttValue
            break;
         case 'TEXTAREA':  // 읽기순서 라벨 - title - placeholder - 멀티파인 편집창
            strAttValue = document.querySelector('[for="' + eleid +'"]') ? document.querySelector('[for="' + eleid +'"]').innerText : '';
            strAttValue = strAttValue + ( element.getAttribute ? element.getAttribute('title') : '' );
            strAttValue = strAttValue + (element.getAttribute ? element.getAttribute('placeholder') : '');
            strAttType = "멀티라인 편집창" + " "
            strReadText =  strAttValue + strAttType 
            break;
         case 'AREA': 
            strAttValue = element.getAttribute ? element.getAttribute('alt') : '';
            strAttValue =  strAttValue + (element.getAttribute ? element.getAttribute('title') : '');
            strAttType = "이미지맵" + " ";
            strReadText =  strAttValue + strAttType 
            break;
 
         default:
             strAttType = "";
             strAttValue = "";
      }
      result += strReadText;
    }





    //    result = result.replace('null', ' 쉼 ')
    result = result.replace('null', ' ')
    //result = result.replace('10giga', '십기가')

    //console.log ("----return result = " + result)
    return result;
  },


  
  replaceSpecialKey: function (element) {
    var returnString = "";
    return element;
  },
  
 
  replaceProductName: function (strText) {
//    strText = strText.replace(" ", "");
    return strText;
  },
  
 
  stop: function () {
    chrome.runtime.sendMessage({
      payload: "stop"
    });
  },

  play: function (msg) {
    chrome.runtime.sendMessage({
      payload: "play",
      message: this.replaceProductName(this.replaceSpecialKey(msg))
    });
  }
}

window.addEventListener("load", function (event) {
  var KwaxTTSReadobj = new KwaxTTS();
  KwaxTTSReadobj.observe();
  window.KwaxTTSReadobj = KwaxTTSReadobj;
});