//수정내용 돋보기 기능 추가
(function() {
achecker = window.achecker || {};
achecker.colorInspector = {
	inspecting: false,
	callback: null,
	doCapture: true,
	init: function() {
		var $swatch = document.createElement("div");
		$swatch.id = "kwax-colorSwatch";
		$swatch.style.display = "none";
		$swatch.style.position = "fixed";
		$swatch.style.zIndex = 10000000000000001;
		$swatch.style.padding = "3px 5px";
		$swatch.style.border = "solid 1px #333";
		$swatch.style.borderRadius = "3px";
		$swatch.style.color = "#000";
		$swatch.style.font = "13px/1.2 Verdana, sans-serif";
		$swatch.style.backgroundColor = "#fff";
		document.body.appendChild($swatch);
		achecker.colorInspector.$swatch = document.getElementById("kwax-colorSwatch");
		
		//magnifier init
		var magnifier = KWAX.func.magnifyDocument();
		document.body.appendChild(magnifier);
		achecker.colorInspector.magnifier = document.getElementById("kwax-magnifier");

		window.addEventListener('resize', function() {
			achecker.colorInspector.doCapture=true;
		}, true);
		window.addEventListener('scroll', function() {
			achecker.colorInspector.doCapture=true;
		}, true);
		
	},
	startInspect: function(callback) {

		if (!document.getElementById("kwax-colorSwatch")) {
			// 명도대비 색선택버튼 클릭 시 검사창 가리기

			//필터 적용된 경우 필터 유지
			let hasGrayFilter = getComputedStyle(document.documentElement).filter === 'grayscale(1)' ? '; filter: grayscale(100%)' : '';

			document.documentElement.setAttribute('style', 'margin-left: 0px' + hasGrayFilter);
			document.getElementById('kwax-result').setAttribute('style', 'display: none');
			document.getElementById('resultScroll').setAttribute('style', 'display: none');

			// 스크롤은 동적 노드 멈추게 하기 위해 클릭시 포커싱 이동한 것을 원래대로 돌리기 위함
			let scrollX = window.scrollX;
			let scrollY = window.scrollY;

			//bxslider, carousel 동적인 노드들 멈추게 하기
			let isLotate = document.documentElement.querySelectorAll('[class*="stop"]');
			if(isLotate){
				for(let i = 0; i < isLotate.length; i++){
					isLotate[i].click();
				}
				window.scrollTo(scrollX,scrollY);
			}
			setTimeout(function(){
				achecker.colorInspector.init();
			}, 100);
		};
		setTimeout(function(){
			achecker.colorInspector.callback = callback;
			achecker.colorInspector.inspecting = true;
			achecker.colorInspector.overrideCursor();
			achecker.colorInspector._addInspectListeners();
			achecker.colorInspector.openSwatch();
		}, 150);
	},
	stopInspect: function() {
		achecker.colorInspector.callback = null;
		achecker.colorInspector.inspecting = false;
		achecker.colorInspector.undoCursor();
		achecker.colorInspector._removeInspectListeners();
		achecker.colorInspector.hideSwatch();
		document.getElementById('kwax-colorSwatch').remove();
		document.getElementById('_acheckeroverlay').remove();
		document.getElementById('kwax-magnifier').remove();

		//필터 적용된 경우 필터 유지
		let hasGrayFilter = getComputedStyle(document.documentElement).filter === 'grayscale(1)' ? 'filter: grayscale(100%)' : '';

		document.documentElement.setAttribute('style', hasGrayFilter);
		document.getElementById('kwax-result').setAttribute('style', '');
		document.getElementById('resultScroll').setAttribute('style', '');
		achecker.colorInspector.doCapture = true;

		//bxslider, carousel 등 동적인 노드들 다시 시작하기
		let isLotate = document.documentElement.querySelectorAll('[class*="start"]');
		if(isLotate){
			let scrollX = window.scrollX;
			let scrollY = window.scrollY;
			for(let i = 0; i < isLotate.length; i++){
				isLotate[i].click();
			}
			window.scrollTo(scrollX,scrollY);
		}
	},
	openSwatch: function() {
		achecker.colorInspector.$swatch.style.display = "block";
	},
	hideSwatch: function() {
		achecker.colorInspector.$swatch.style.display = "none";
	},
	overrideCursor: function() {
		document.body.className += ' kwax-colorInspecting';
	},
	undoCursor: function() {
		document.body.className = document.body.className.replace(' kwax-colorInspecting', '');
	},
	onMouseMove: function(e) {
	    e.preventDefault();
		e.stopPropagation();
		chrome.extension.sendMessage({
			dataUrl: dataURI,
			x:e.clientX,
			y:e.clientY,
			win:[window.innerWidth,window.innerHeight],
			next:'achecker.colorInspector.onMouseMovePick'
		});
		KWAX.func.moveMagnifier(e);
		achecker.colorInspector.doCapture = false;

		var $swatch = achecker.colorInspector.$swatch;
		$swatch.style.left = (e.clientX + 5) +"px";
		$swatch.style.top = (e.clientY + 6) +"px";

	},
	onMouseMovePick: function(color) {
		color = achecker.rainbowColor.toHex(color);
		achecker.colorInspector.changeColor(color);
	},
	pageClick: function(e) {
		var $swatch = achecker.colorInspector.$swatch,
		color = $swatch.textContent;

		achecker.colorInspector.callback(color);
		achecker.colorInspector.stopInspect();

		e.preventDefault();
		e.stopPropagation();
	},
	changeColor: function(color, show) {
		var $swatch = achecker.colorInspector.$swatch;
		var blackText = achecker.rainbowColor.blackText(color);
		$swatch.style.backgroundColor = color;
		$swatch.style.color = blackText ? 'black' : 'white';
		$swatch.textContent = achecker.rainbowColor.toHex(color);
	},
	onMouseUp: function(e) {
		e.stopPropagation(); e.preventDefault();
		chrome.extension.sendMessage({
			// capture:achecker.colorInspector.doCapture,
			dataUrl: dataURI,
			x:e.clientX,
			y:e.clientY,
			win:[window.innerWidth,window.innerHeight],
			next:'achecker.colorInspector.onMouseUpPick'
		});
		achecker.colorInspector.doCapture = false;
	},
	onMouseUpPick: function(color) {
		color = achecker.rainbowColor.toHex(color);
		achecker.colorInspector.callback(color);
		achecker.colorInspector.stopInspect();
	},
	_addInspectListeners: function() {
		window.addEventListener("mousemove", achecker.colorInspector.onMouseMove, true);
		window.addEventListener("mouseup", achecker.colorInspector.onMouseUp, true);
	},
	_removeInspectListeners: function() {
		window.removeEventListener("mousemove", achecker.colorInspector.onMouseMove, true);
		window.removeEventListener("mouseup", achecker.colorInspector.onMouseUp, true);
	},
};
})();
